/*
	sekiban.c
	
	:
		 IBM PC n{ DOS iDOS/Vj
		iPC-9801/FM-R nł͓삵܂j
		ȂƂ DOS/V ̃tHghCoCXg[Ă邱ƁB

	쐬:
		Turbo C 1.01:	tcc sekiban.c int86x2.lib
		LSI-C86 3.30c:	lcc sekiban.c lsic\int86x2.lib -lintlib
			iŌ -lintlib ͂ȂĂj
		OpenWatcom:		wcl -bt=dos sekiban.c int86x2.lib
		DigitalMars:	sc -msd sekiban.c int86x2.lib

	p@:
		sekiban [-Wwidth] [-Hheight] [-Ssetchar] [-Rresethar] string
		
		-Wwidth		ǂݏotHǵipł́jwB
					width  1  16 ܂ł̐B
					-W IvVw莞 -W8 ƓB
		-Hheight	ǂݏotHg̍wB
					height  1  32 ܂ł̐B
					-H IvVw莞 -H16 ƓB
		-Ssetchar	setchar ̓sNZɑ镶B
					-S IvVw莞 "-S" ƓB
		-Rresetchar	resetchar ͔wiɑ镶B
					-R IvVw莞 "-R" ƓB
	
	p:
		sekiban 
		sekiban "-so" "-r " (߁)

*/


#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "int86x2.h"

int
psraster(unsigned ccode, int x, int y, int charwidth, int fwidth, int fheight, const char *dst, const char *drt)
{
	union REGS2 r;
	struct SREGS sr;
	unsigned f_off, f_seg;
	int i;
	char *s;
	char b[128];			/* max: 32dot *32bytes */

	fwidth *= charwidth;

	r.x.ax = 0x5000;
	r.x.bx = (charwidth > 1) ? 0x0100 : 0x0000;
	r.h.dh = fwidth;
	r.h.dl = fheight;
	r.x.bp = 0;
	r.x.flags = _readflags(); /* ݃tOƂftHgԂňp */
	int86x2(0x15, &r, &r, &sr);
	if (r.x.cflag == 0 && r.h.ah == 0) {
		f_off = r.x.bx;
		f_seg = sr.es;
		r.x.cx = ccode;
		/* DigitalMars  FP_OFF  FP_SEG ƂȂ񂩔ɈႤc */
		sr.es = ((unsigned long)(char far *)b >> 16);
		r.x.si = (unsigned)((unsigned long)(char far *)b & 0xffffU);
		farcall86x2(f_off, f_seg, &r, &r, &sr);
		r.h.ah = r.h.al;
	}
	if (r.h.ah != 0) memset(b, 0, sizeof(b));
	
	s = b + ((fwidth + 7) >> 3) * y;
	for(i=0; i< fwidth; i++) {
		if (s[i >> 3] & (0x80 >> (i & 7))) {
			printf("%s", dst);
		}
		else {
			printf("%s", drt);
		}
	}
	
	return 1;
}

int
pnewline()
{
	printf("\n");
	return 1;
}

int
psekiban(const unsigned char *s_top, int fwidth, int fheight, const char *dst, const char *drt)
{
	const unsigned char *s;
	unsigned char c;
	unsigned ck;
	int cw;
	int x, y;
	int rc;
	
	for(y=0; y<fheight; y++) {
		s = s_top;
		x = 0;
		while((c = *s) != '\0') {
			if ((c >= 0x81 && c <= 0x9f) || (c >= 0xe0 && c <= 0xfc)) {
				ck = (unsigned)c << 8;
				c = s[1];
				if (c == '\0') break;
				ck |= c;
				cw = 2;
			}
			else {
				ck = c;
				cw = 1;
			}
			rc = psraster(ck, x, y, cw, fwidth, fheight, dst, drt);
			if (rc <= 0) return rc;
			s += cw;
			x += cw;
		}
		rc = pnewline();
	}
	return rc;
}


int optW = 8;
int optH = 16;

char *char_set = "";
char *char_reset = "";

int
main(int argc, char *argv[])
{
	int n;
	char c, *s;
	
	while(--argc) {
		s = *++argv;
		if (*s == '-' || *s == '/') {
			c = s[1];
			switch(c) {
			  case 'H':
			  case 'h':
				n = atoi(s + 2);
				if (n <= 0 || n > 32) {
					fprintf(stderr, "invalid parameter (height)\n");
					exit(1);
				}
				optH = n;
				continue;
			  case 'w':
			  case 'W':
				n = atoi(s + 2);
				if (n <= 0 || n > 16) {
					fprintf(stderr, "invalid parameter (width)\n");
					exit(1);
				}
				optH = n;
				continue;
			  case 'S':
			  case 's':
				char_set = s + 2;
				continue;
			  case 'R':
			  case 'r':
				char_reset = s + 2;
				continue;
			}
		}
		psekiban((unsigned char *)s, optW, optH, char_set, char_reset);
		break;
	}
	return 0;
}
